<%@ Page Language="C#" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Xml" %>
<%@ Import Namespace="System.Xml.Serialization" %>
<html>
<head>
<script runat="server">
string usersfile = "users.xml";

public class AuthInfo {
	public UserInfo[] Users;
}

public class UserInfo {
	public string name;
	public string password;
	public string role;
}

void Page_Load(object sender, EventArgs e) {
	if (User == null) {
		Message.Text = "null";
	} else {
		Message.Text = User.Identity.Name;
	}
}

void login_Click(object sender, EventArgs e) {
	UserInfo userinfo;
	if ((userinfo = Authenticate(tbUsername.Text, tbPassword.Text)) != null) {
		RedirectFromLoginPage(userinfo.name, userinfo.role, persist.Checked);
	} else {
		Message.Text = "s܂BpX[hmFĂ";
	}
}

UserInfo Authenticate(string username, string password) {
	AuthInfo authinfo = null;
	UserInfo result = null;
	string filename = Server.MapPath(".") + "\\" + usersfile;
	try {
		XmlSerializer serializer = new XmlSerializer(typeof(AuthInfo));
		FileStream stream = new FileStream(filename, FileMode.Open, FileAccess.Read);
		authinfo = (AuthInfo) serializer.Deserialize(stream);
		stream.Close();
	}
	catch (Exception ex) {
		Message.Text = ex.Message;
	}

	if (authinfo != null) {
		foreach (UserInfo u in authinfo.Users) {
			if (u.name == username && u.password == password)
				result = u;
		}
	}

	return result;
}

void RedirectFromLoginPage(string username, string role, bool persistent) {
	FormsAuthenticationTicket ticket = new FormsAuthenticationTicket(
		1,
		username,
		DateTime.Now,
		DateTime.Now.AddMinutes(60),
		persistent,
		role);

	HttpCookie cookie = new HttpCookie(
		FormsAuthentication.FormsCookieName,
		FormsAuthentication.Encrypt(ticket));
	if (persistent) {
		cookie.Expires = DateTime.Now.AddYears(50);
	}
	Response.Cookies.Add(cookie);

	Response.Redirect(FormsAuthentication.GetRedirectUrl(username, persistent));
}
</script>
</head>
<body>
	<form runat="server">
		<p>UserName : <asp:TextBox id="tbUsername" runat="server" /></p>
		<p>Password : <asp:TextBox id="tbPassword" TextMode="Password" runat="server" /></p>
		<p>
			<asp:CheckBox id="persist"
				Text="F؏L" runat="server"/>
			<asp:Button id="login" Text="OC"
				OnClick="login_Click" runat="server" />
		</p>
		<p><asp:Label id="Message" ForeColor="red" runat="server" /></p>
	</form>
</body>
</html>

